## Copyright (C) 2020 John Donoghue <john.donoghue@ieee.org>
## 
## This program is free software: you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see
## <https://www.gnu.org/licenses/>.

classdef pigpio_base
  ## auto generated file from pigpio.h
  properties  (Access = protected, Constant = true)
    # command consts
    PI_CMD_MODES = 0;
    PI_CMD_MODEG = 1;
    PI_CMD_PUD = 2;
    PI_CMD_READ = 3;
    PI_CMD_WRITE = 4;
    PI_CMD_PWM = 5;
    PI_CMD_PRS = 6;
    PI_CMD_PFS = 7;
    PI_CMD_SERVO = 8;
    PI_CMD_WDOG = 9;
    PI_CMD_BR1 = 10;
    PI_CMD_BR2 = 11;
    PI_CMD_BC1 = 12;
    PI_CMD_BC2 = 13;
    PI_CMD_BS1 = 14;
    PI_CMD_BS2 = 15;
    PI_CMD_TICK = 16;
    PI_CMD_HWVER = 17;
    PI_CMD_NO = 18;
    PI_CMD_NB = 19;
    PI_CMD_NP = 20;
    PI_CMD_NC = 21;
    PI_CMD_PRG = 22;
    PI_CMD_PFG = 23;
    PI_CMD_PRRG = 24;
    PI_CMD_HELP = 25;
    PI_CMD_PIGPV = 26;
    PI_CMD_WVCLR = 27;
    PI_CMD_WVAG = 28;
    PI_CMD_WVAS = 29;
    PI_CMD_WVGO = 30;
    PI_CMD_WVGOR = 31;
    PI_CMD_WVBSY = 32;
    PI_CMD_WVHLT = 33;
    PI_CMD_WVSM = 34;
    PI_CMD_WVSP = 35;
    PI_CMD_WVSC = 36;
    PI_CMD_TRIG = 37;
    PI_CMD_PROC = 38;
    PI_CMD_PROCD = 39;
    PI_CMD_PROCR = 40;
    PI_CMD_PROCS = 41;
    PI_CMD_SLRO = 42;
    PI_CMD_SLR = 43;
    PI_CMD_SLRC = 44;
    PI_CMD_PROCP = 45;
    PI_CMD_MICS = 46;
    PI_CMD_MILS = 47;
    PI_CMD_PARSE = 48;
    PI_CMD_WVCRE = 49;
    PI_CMD_WVDEL = 50;
    PI_CMD_WVTX = 51;
    PI_CMD_WVTXR = 52;
    PI_CMD_WVNEW = 53;
    PI_CMD_I2CO = 54;
    PI_CMD_I2CC = 55;
    PI_CMD_I2CRD = 56;
    PI_CMD_I2CWD = 57;
    PI_CMD_I2CWQ = 58;
    PI_CMD_I2CRS = 59;
    PI_CMD_I2CWS = 60;
    PI_CMD_I2CRB = 61;
    PI_CMD_I2CWB = 62;
    PI_CMD_I2CRW = 63;
    PI_CMD_I2CWW = 64;
    PI_CMD_I2CRK = 65;
    PI_CMD_I2CWK = 66;
    PI_CMD_I2CRI = 67;
    PI_CMD_I2CWI = 68;
    PI_CMD_I2CPC = 69;
    PI_CMD_I2CPK = 70;
    PI_CMD_SPIO = 71;
    PI_CMD_SPIC = 72;
    PI_CMD_SPIR = 73;
    PI_CMD_SPIW = 74;
    PI_CMD_SPIX = 75;
    PI_CMD_SERO = 76;
    PI_CMD_SERC = 77;
    PI_CMD_SERRB = 78;
    PI_CMD_SERWB = 79;
    PI_CMD_SERR = 80;
    PI_CMD_SERW = 81;
    PI_CMD_SERDA = 82;
    PI_CMD_GDC = 83;
    PI_CMD_GPW = 84;
    PI_CMD_HC = 85;
    PI_CMD_HP = 86;
    PI_CMD_CF1 = 87;
    PI_CMD_CF2 = 88;
    PI_CMD_BI2CC = 89;
    PI_CMD_BI2CO = 90;
    PI_CMD_BI2CZ = 91;
    PI_CMD_I2CZ = 92;
    PI_CMD_WVCHA = 93;
    PI_CMD_SLRI = 94;
    PI_CMD_CGI = 95;
    PI_CMD_CSI = 96;
    PI_CMD_FG = 97;
    PI_CMD_FN = 98;
    PI_CMD_NOIB = 99;
    PI_CMD_WVTXM = 100;
    PI_CMD_WVTAT = 101;
    PI_CMD_PADS = 102;
    PI_CMD_PADG = 103;
    PI_CMD_FO = 104;
    PI_CMD_FC = 105;
    PI_CMD_FR = 106;
    PI_CMD_FW = 107;
    PI_CMD_FS = 108;
    PI_CMD_FL = 109;
    PI_CMD_SHELL = 110;
    PI_CMD_BSPIC = 111;
    PI_CMD_BSPIO = 112;
    PI_CMD_BSPIX = 113;
    PI_CMD_BSCX = 114;
    PI_CMD_EVM = 115;
    PI_CMD_EVT = 116;
    PI_CMD_PROCU = 117;
    PI_CMD_WVCAP = 118;
    PI_CMD_SCRIPT = 800;
    PI_CMD_ADD = 800;
    PI_CMD_AND = 801;
    PI_CMD_CALL = 802;
    PI_CMD_CMDR = 803;
    PI_CMD_CMDW = 804;
    PI_CMD_CMP = 805;
    PI_CMD_DCR = 806;
    PI_CMD_DCRA = 807;
    PI_CMD_DIV = 808;
    PI_CMD_HALT = 809;
    PI_CMD_INR = 810;
    PI_CMD_INRA = 811;
    PI_CMD_JM = 812;
    PI_CMD_JMP = 813;
    PI_CMD_JNZ = 814;
    PI_CMD_JP = 815;
    PI_CMD_JZ = 816;
    PI_CMD_TAG = 817;
    PI_CMD_LD = 818;
    PI_CMD_LDA = 819;
    PI_CMD_LDAB = 820;
    PI_CMD_MLT = 821;
    PI_CMD_MOD = 822;
    PI_CMD_NOP = 823;
    PI_CMD_OR = 824;
    PI_CMD_POP = 825;
    PI_CMD_POPA = 826;
    PI_CMD_PUSH = 827;
    PI_CMD_PUSHA = 828;
    PI_CMD_RET = 829;
    PI_CMD_RL = 830;
    PI_CMD_RLA = 831;
    PI_CMD_RR = 832;
    PI_CMD_RRA = 833;
    PI_CMD_STA = 834;
    PI_CMD_STAB = 835;
    PI_CMD_SUB = 836;
    PI_CMD_SYS = 837;
    PI_CMD_WAIT = 838;
    PI_CMD_X = 839;
    PI_CMD_XA = 840;
    PI_CMD_XOR = 841;
    PI_CMD_EVTWT = 842;
  endproperties

  properties  (Access = public, Constant = true)
    # file open constants
    FILE_SLOTS = 16;
    FILE_NONE = 0;
    FILE_MIN = 1;
    FILE_READ = 1;
    FILE_WRITE = 2;
    FILE_RW = 3;
    FILE_APPEND = 4;
    FILE_CREATE = 8;
    FILE_TRUNC = 16;
    FILE_MAX = 31;

    # file seek constants
    FROM_START = 0;
    FROM_CURRENT = 1;
    FROM_END = 2;

    # error code constants
    PI_INIT_FAILED = -1;
    PI_BAD_USER_GPIO = -2;
    PI_BAD_GPIO = -3;
    PI_BAD_MODE = -4;
    PI_BAD_LEVEL = -5;
    PI_BAD_PUD = -6;
    PI_BAD_PULSEWIDTH = -7;
    PI_BAD_DUTYCYCLE = -8;
    PI_BAD_TIMER = -9;
    PI_BAD_MS = -10;
    PI_BAD_TIMETYPE = -11;
    PI_BAD_SECONDS = -12;
    PI_BAD_MICROS = -13;
    PI_TIMER_FAILED = -14;
    PI_BAD_WDOG_TIMEOUT = -15;
    PI_NO_ALERT_FUNC = -16;
    PI_BAD_CLK_PERIPH = -17;
    PI_BAD_CLK_SOURCE = -18;
    PI_BAD_CLK_MICROS = -19;
    PI_BAD_BUF_MILLIS = -20;
    PI_BAD_DUTYRANGE = -21;
    PI_BAD_DUTY_RANGE = -21;
    PI_BAD_SIGNUM = -22;
    PI_BAD_PATHNAME = -23;
    PI_NO_HANDLE = -24;
    PI_BAD_HANDLE = -25;
    PI_BAD_IF_FLAGS = -26;
    PI_BAD_CHANNEL = -27;
    PI_BAD_PRIM_CHANNEL = -27;
    PI_BAD_SOCKET_PORT = -28;
    PI_BAD_FIFO_COMMAND = -29;
    PI_BAD_SECO_CHANNEL = -30;
    PI_NOT_INITIALISED = -31;
    PI_INITIALISED = -32;
    PI_BAD_WAVE_MODE = -33;
    PI_BAD_CFG_INTERNAL = -34;
    PI_BAD_WAVE_BAUD = -35;
    PI_TOO_MANY_PULSES = -36;
    PI_TOO_MANY_CHARS = -37;
    PI_NOT_SERIAL_GPIO = -38;
    PI_BAD_SERIAL_STRUC = -39;
    PI_BAD_SERIAL_BUF = -40;
    PI_NOT_PERMITTED = -41;
    PI_SOME_PERMITTED = -42;
    PI_BAD_WVSC_COMMND = -43;
    PI_BAD_WVSM_COMMND = -44;
    PI_BAD_WVSP_COMMND = -45;
    PI_BAD_PULSELEN = -46;
    PI_BAD_SCRIPT = -47;
    PI_BAD_SCRIPT_ID = -48;
    PI_BAD_SER_OFFSET = -49;
    PI_GPIO_IN_USE = -50;
    PI_BAD_SERIAL_COUNT = -51;
    PI_BAD_PARAM_NUM = -52;
    PI_DUP_TAG = -53;
    PI_TOO_MANY_TAGS = -54;
    PI_BAD_SCRIPT_CMD = -55;
    PI_BAD_VAR_NUM = -56;
    PI_NO_SCRIPT_ROOM = -57;
    PI_NO_MEMORY = -58;
    PI_SOCK_READ_FAILED = -59;
    PI_SOCK_WRIT_FAILED = -60;
    PI_TOO_MANY_PARAM = -61;
    PI_NOT_HALTED = -62;
    PI_SCRIPT_NOT_READY = -62;
    PI_BAD_TAG = -63;
    PI_BAD_MICS_DELAY = -64;
    PI_BAD_MILS_DELAY = -65;
    PI_BAD_WAVE_ID = -66;
    PI_TOO_MANY_CBS = -67;
    PI_TOO_MANY_OOL = -68;
    PI_EMPTY_WAVEFORM = -69;
    PI_NO_WAVEFORM_ID = -70;
    PI_I2C_OPEN_FAILED = -71;
    PI_SER_OPEN_FAILED = -72;
    PI_SPI_OPEN_FAILED = -73;
    PI_BAD_I2C_BUS = -74;
    PI_BAD_I2C_ADDR = -75;
    PI_BAD_SPI_CHANNEL = -76;
    PI_BAD_FLAGS = -77;
    PI_BAD_SPI_SPEED = -78;
    PI_BAD_SER_DEVICE = -79;
    PI_BAD_SER_SPEED = -80;
    PI_BAD_PARAM = -81;
    PI_I2C_WRITE_FAILED = -82;
    PI_I2C_READ_FAILED = -83;
    PI_BAD_SPI_COUNT = -84;
    PI_SER_WRITE_FAILED = -85;
    PI_SER_READ_FAILED = -86;
    PI_SER_READ_NO_DATA = -87;
    PI_UNKNOWN_COMMAND = -88;
    PI_SPI_XFER_FAILED = -89;
    PI_BAD_POINTER = -90;
    PI_NO_AUX_SPI = -91;
    PI_NOT_PWM_GPIO = -92;
    PI_NOT_SERVO_GPIO = -93;
    PI_NOT_HCLK_GPIO = -94;
    PI_NOT_HPWM_GPIO = -95;
    PI_BAD_HPWM_FREQ = -96;
    PI_BAD_HPWM_DUTY = -97;
    PI_BAD_HCLK_FREQ = -98;
    PI_BAD_HCLK_PASS = -99;
    PI_HPWM_ILLEGAL = -100;
    PI_BAD_DATABITS = -101;
    PI_BAD_STOPBITS = -102;
    PI_MSG_TOOBIG = -103;
    PI_BAD_MALLOC_MODE = -104;
    PI_TOO_MANY_SEGS = -105;
    PI_BAD_I2C_SEG = -106;
    PI_BAD_SMBUS_CMD = -107;
    PI_NOT_I2C_GPIO = -108;
    PI_BAD_I2C_WLEN = -109;
    PI_BAD_I2C_RLEN = -110;
    PI_BAD_I2C_CMD = -111;
    PI_BAD_I2C_BAUD = -112;
    PI_CHAIN_LOOP_CNT = -113;
    PI_BAD_CHAIN_LOOP = -114;
    PI_CHAIN_COUNTER = -115;
    PI_BAD_CHAIN_CMD = -116;
    PI_BAD_CHAIN_DELAY = -117;
    PI_CHAIN_NESTING = -118;
    PI_CHAIN_TOO_BIG = -119;
    PI_DEPRECATED = -120;
    PI_BAD_SER_INVERT = -121;
    PI_BAD_EDGE = -122;
    PI_BAD_ISR_INIT = -123;
    PI_BAD_FOREVER = -124;
    PI_BAD_FILTER = -125;
    PI_BAD_PAD = -126;
    PI_BAD_STRENGTH = -127;
    PI_FIL_OPEN_FAILED = -128;
    PI_BAD_FILE_MODE = -129;
    PI_BAD_FILE_FLAG = -130;
    PI_BAD_FILE_READ = -131;
    PI_BAD_FILE_WRITE = -132;
    PI_FILE_NOT_ROPEN = -133;
    PI_FILE_NOT_WOPEN = -134;
    PI_BAD_FILE_SEEK = -135;
    PI_NO_FILE_MATCH = -136;
    PI_NO_FILE_ACCESS = -137;
    PI_FILE_IS_A_DIR = -138;
    PI_BAD_SHELL_STATUS = -139;
    PI_BAD_SCRIPT_NAME = -140;
    PI_BAD_SPI_BAUD = -141;
    PI_NOT_SPI_GPIO = -142;
    PI_BAD_EVENT_ID = -143;
    PI_CMD_INTERRUPTED = -144;
    PI_NOT_ON_BCM2711 = -145;
    PI_ONLY_ON_BCM2711 = -146;
  endproperties

  methods
    function err = error_text (self, errorcode)
      if nargin < 2
        errorcode = 0;
      endif

      switch errorcode
        case 0, err = '';
        case -1, err="gpioInitialise failed";
        case -2, err="GPIO not 0-31";
        case -3, err="GPIO not 0-53";
        case -4, err="mode not 0-7";
        case -5, err="level not 0-1";
        case -6, err="pud not 0-2";
        case -7, err="pulsewidth not 0 or 500-2500";
        case -8, err="dutycycle outside set range";
        case -9, err="timer not 0-9";
        case -10, err="ms not 10-60000";
        case -11, err="timetype not 0-1";
        case -12, err="seconds < 0";
        case -13, err="micros not 0-999999";
        case -14, err="gpioSetTimerFunc failed";
        case -15, err="timeout not 0-60000";
        case -16, err="DEPRECATED";
        case -17, err="clock peripheral not 0-1";
        case -18, err="DEPRECATED";
        case -19, err="clock micros not 1, 2, 4, 5, 8, or 10";
        case -20, err="buf millis not 100-10000";
        case -21, err="dutycycle range not 25-40000";
        case -21, err="DEPRECATED (use PI_BAD_DUTYRANGE)";
        case -22, err="signum not 0-63";
        case -23, err="can't open pathname";
        case -24, err="no handle available";
        case -25, err="unknown handle";
        case -26, err="ifFlags > 4";
        case -27, err="DMA channel not 0-15";
        case -27, err="DMA primary channel not 0-15";
        case -28, err="socket port not 1024-32000";
        case -29, err="unrecognized fifo command";
        case -30, err="DMA secondary channel not 0-15";
        case -31, err="function called before gpioInitialise";
        case -32, err="function called after gpioInitialise";
        case -33, err="waveform mode not 0-3";
        case -34, err="bad parameter in gpioCfgInternals call";
        case -35, err="baud rate not 50-250K(RX)/50-1M(TX)";
        case -36, err="waveform has too many pulses";
        case -37, err="waveform has too many chars";
        case -38, err="no bit bang serial read on GPIO";
        case -39, err="bad (null) serial structure parameter";
        case -40, err="bad (null) serial buf parameter";
        case -41, err="GPIO operation not permitted";
        case -42, err="one or more GPIO not permitted";
        case -43, err="bad WVSC subcommand";
        case -44, err="bad WVSM subcommand";
        case -45, err="bad WVSP subcommand";
        case -46, err="trigger pulse length not 1-100";
        case -47, err="invalid script";
        case -48, err="unknown script id";
        case -49, err="add serial data offset > 30 minutes";
        case -50, err="GPIO already in use";
        case -51, err="must read at least a byte at a time";
        case -52, err="script parameter id not 0-9";
        case -53, err="script has duplicate tag";
        case -54, err="script has too many tags";
        case -55, err="illegal script command";
        case -56, err="script variable id not 0-149";
        case -57, err="no more room for scripts";
        case -58, err="can't allocate temporary memory";
        case -59, err="socket read failed";
        case -60, err="socket write failed";
        case -61, err="too many script parameters (> 10)";
        case -62, err="DEPRECATED";
        case -62, err="script initialising";
        case -63, err="script has unresolved tag";
        case -64, err="bad MICS delay (too large)";
        case -65, err="bad MILS delay (too large)";
        case -66, err="non existent wave id";
        case -67, err="No more CBs for waveform";
        case -68, err="No more OOL for waveform";
        case -69, err="attempt to create an empty waveform";
        case -70, err="no more waveforms";
        case -71, err="can't open I2C device";
        case -72, err="can't open serial device";
        case -73, err="can't open SPI device";
        case -74, err="bad I2C bus";
        case -75, err="bad I2C address";
        case -76, err="bad SPI channel";
        case -77, err="bad i2c/spi/ser open flags";
        case -78, err="bad SPI speed";
        case -79, err="bad serial device name";
        case -80, err="bad serial baud rate";
        case -81, err="bad i2c/spi/ser parameter";
        case -82, err="i2c write failed";
        case -83, err="i2c read failed";
        case -84, err="bad SPI count";
        case -85, err="ser write failed";
        case -86, err="ser read failed";
        case -87, err="ser read no data available";
        case -88, err="unknown command";
        case -89, err="spi xfer/read/write failed";
        case -90, err="bad (NULL) pointer";
        case -91, err="no auxiliary SPI on Pi A or B";
        case -92, err="GPIO is not in use for PWM";
        case -93, err="GPIO is not in use for servo pulses";
        case -94, err="GPIO has no hardware clock";
        case -95, err="GPIO has no hardware PWM";
        case -96, err="invalid hardware PWM frequency";
        case -97, err="hardware PWM dutycycle not 0-1M";
        case -98, err="invalid hardware clock frequency";
        case -99, err="need password to use hardware clock 1";
        case -100, err="illegal, PWM in use for main clock";
        case -101, err="serial data bits not 1-32";
        case -102, err="serial (half) stop bits not 2-8";
        case -103, err="socket/pipe message too big";
        case -104, err="bad memory allocation mode";
        case -105, err="too many I2C transaction segments";
        case -106, err="an I2C transaction segment failed";
        case -107, err="SMBus command not supported by driver";
        case -108, err="no bit bang I2C in progress on GPIO";
        case -109, err="bad I2C write length";
        case -110, err="bad I2C read length";
        case -111, err="bad I2C command";
        case -112, err="bad I2C baud rate, not 50-500k";
        case -113, err="bad chain loop count";
        case -114, err="empty chain loop";
        case -115, err="too many chain counters";
        case -116, err="bad chain command";
        case -117, err="bad chain delay micros";
        case -118, err="chain counters nested too deeply";
        case -119, err="chain is too long";
        case -120, err="deprecated function removed";
        case -121, err="bit bang serial invert not 0 or 1";
        case -122, err="bad ISR edge value, not 0-2";
        case -123, err="bad ISR initialisation";
        case -124, err="loop forever must be last command";
        case -125, err="bad filter parameter";
        case -126, err="bad pad number";
        case -127, err="bad pad drive strength";
        case -128, err="file open failed";
        case -129, err="bad file mode";
        case -130, err="bad file flag";
        case -131, err="bad file read";
        case -132, err="bad file write";
        case -133, err="file not open for read";
        case -134, err="file not open for write";
        case -135, err="bad file seek";
        case -136, err="no files match pattern";
        case -137, err="no permission to access file";
        case -138, err="file is a directory";
        case -139, err="bad shell return status";
        case -140, err="bad script name";
        case -141, err="bad SPI baud rate, not 50-500k";
        case -142, err="no bit bang SPI in progress on GPIO";
        case -143, err="bad event id";
        case -144, err="Used by Python";
        case -145, err="not available on BCM2711";
        case -146, err="only available on BCM2711";
        otherwise, err = sprintf('error %d', errorcode);
      endswitch
    endfunction
  endmethods
endclassdef
